summaryrefslogtreecommitdiff
path: root/lib/dfsan/scripts/check_custom_wrappers.sh
diff options
context:
space:
mode:
authorLorenzo Martignoni <martignlo@google.com>2013-11-27 11:50:44 +0000
committerLorenzo Martignoni <martignlo@google.com>2013-11-27 11:50:44 +0000
commit2739bc6de16a97993fffe1fbe604b62e6fab5497 (patch)
treecf53a880884d9fdafa0a032466115824362c524b /lib/dfsan/scripts/check_custom_wrappers.sh
parentf08d541bb2de3a09a5f1b0f647d62aed6821bcc8 (diff)
Added missing lib/dfsan/scripts/check_custom_wrappers.sh
git-svn-id: https://llvm.org/svn/llvm-project/compiler-rt/trunk@195838 91177308-0d34-0410-b5e6-96231b3b80d8
Diffstat (limited to 'lib/dfsan/scripts/check_custom_wrappers.sh')
-rwxr-xr-xlib/dfsan/scripts/check_custom_wrappers.sh50
1 files changed, 50 insertions, 0 deletions
diff --git a/lib/dfsan/scripts/check_custom_wrappers.sh b/lib/dfsan/scripts/check_custom_wrappers.sh
new file mode 100755
index 000000000..cf0d6e426
--- /dev/null
+++ b/lib/dfsan/scripts/check_custom_wrappers.sh
@@ -0,0 +1,50 @@
+#!/bin/bash
+
+DFSAN_DIR=$(dirname "$0")/../
+DFSAN_CUSTOM_TESTS=${DFSAN_DIR}/lit_tests/custom.c
+DFSAN_CUSTOM_WRAPPERS=${DFSAN_DIR}/dfsan_custom.cc
+DFSAN_ABI_LIST=${DFSAN_DIR}/done_abilist.txt
+
+DIFFOUT=$(mktemp -q /tmp/tmp.XXXXXXXXXX)
+ERRORLOG=$(mktemp -q /tmp/tmp.XXXXXXXXXX)
+
+on_exit() {
+ rm -f ${DIFFOUT} 2> /dev/null
+ rm -f ${ERRORLOG} 2> /dev/null
+}
+
+trap on_exit EXIT
+
+diff -u \
+ <(grep -E "^fun:.*=custom" ${DFSAN_ABI_LIST} | grep -v "dfsan_get_label" \
+ | sed "s/^fun:\(.*\)=custom.*/\1/" | sort ) \
+ <(grep -E "__dfsw.*\(" ${DFSAN_CUSTOM_WRAPPERS} \
+ | sed "s/.*__dfsw_\(.*\)(.*/\1/" \
+ | sort) > ${DIFFOUT}
+if [ $? -ne 0 ]
+then
+ echo -n "The following differences between the ABI list and ">> ${ERRORLOG}
+ echo "the implemented custom wrappers have been found:" >> ${ERRORLOG}
+ cat ${DIFFOUT} >> ${ERRORLOG}
+fi
+
+diff -u \
+ <(grep -E __dfsw_ ${DFSAN_CUSTOM_WRAPPERS} \
+ | sed "s/.*__dfsw_\([^(]*\).*/\1/" \
+ | sort) \
+ <(grep -E "^\\s*test_.*\(\);" ${DFSAN_CUSTOM_TESTS} \
+ | sed "s/.*test_\(.*\)();/\1/" \
+ | sort) > ${DIFFOUT}
+if [ $? -ne 0 ]
+then
+ echo -n "The following differences between the implemented " >> ${ERRORLOG}
+ echo "custom wrappers and the tests have been found:" >> ${ERRORLOG}
+ cat ${DIFFOUT} >> ${ERRORLOG}
+fi
+
+if [[ -s ${ERRORLOG} ]]
+then
+ cat ${ERRORLOG}
+ exit 1
+fi
+